/*
Norman Kuring		9-Feb-2000
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "ppm.h"

void spline(float [],float [],int,float,float,float []);
void splint(float [],float [],float [],int,float,float *);

void main(int argc, char *argv[]){

  FILE		*ifp;
  pixel		scan[1285],outscan[1798];
  int		cols,rows,format,s,p;
  pixval	maxval;
  float		x[643], r[643], g[643], b[643], y2[643], y;

  ppm_init( &argc, argv );
  ifp = pm_openr( argv[1] );
  ppm_readppminit( ifp, &cols, &rows, &maxval, &format);
  if(cols != 1285){
    fprintf(stderr,
    "-E- %s line %d: Input image must have 1285 pixels per scan.\n",
    __FILE__,__LINE__);
    exit(EXIT_FAILURE);
  }
  if(maxval != 255){
    fprintf(stderr,
    "-E- %s line %d: Maxval must equal 255.\n",__FILE__,__LINE__);
    exit(EXIT_FAILURE);
  }
  if(format != RPPM_FORMAT){
    fprintf(stderr,
    "-E- %s line %d: Image must be in PPM format.\n",__FILE__,__LINE__);
    exit(EXIT_FAILURE);
  }

  ppm_writeppminit(stdout, 1798, rows, maxval, 0);

  for(p=0; p<643; p++){
    x[p] = (float)(1156 - 705*tan((643 - p)*0.0015911));
  }

  for(s=0; s<rows; s++){
    int p,i;
    ppm_readppmrow(ifp, scan, cols, maxval, format);
    for(p=0; p<643; p++){
      r[p] = (float)(PPM_GETR(scan[p]));
      g[p] = (float)(PPM_GETG(scan[p]));
      b[p] = (float)(PPM_GETB(scan[p]));
    }
    spline(x,r,643,1e30,1e30,y2);
    for(i=0; i<1156; i++){
      int red;
      splint(x,r,y2,643,(float)i,&y);
      red = (int)(y+0.5);
      if(red <   0) red =   0;
      if(red > 255) red = 255;
      PPM_PUTR(outscan[i],red);
    }
    spline(x,g,643,1e30,1e30,y2);
    for(i=0; i<1156; i++){
      int grn;
      splint(x,g,y2,643,(float)i,&y);
      grn = (int)(y+0.5);
      if(grn <   0) grn =   0;
      if(grn > 255) grn = 255;
      PPM_PUTG(outscan[i],grn);
    }
    spline(x,b,643,1e30,1e30,y2);
    for(i=0; i<1156; i++){
      int blu;
      splint(x,b,y2,643,(float)i,&y);
      blu = (int)(y+0.5);
      if(blu <   0) blu =   0;
      if(blu > 255) blu = 255;
      PPM_PUTB(outscan[i],blu);
    }

    for(i=1156; i<1798; i++){
      p = i - 513;
      outscan[i] = scan[p];
    }

    ppm_writeppmrow(stdout, outscan, 1798, maxval, 0);
    fprintf(stderr,".");
  }
  fprintf(stderr,"\n");
}
